'
 ' Small SDL example to demonstrate dynamically loading 
 ' OpenGL lib and functions
 '
 ' (FYI it was supposed to look like snow in the wind or something...)



PROGRAM "dyngl"
VERSION "0.1"
'CONSOLE

	IMPORT "msvcrt"
	IMPORT "gdi32"
	IMPORT "user32"
	IMPORT "kernel32"
	IMPORT "opengl32"	
	IMPORT "SDL"
	'IMPORT "SDL_mixer"
	'IMPORT "SDL_gfx"
	'IMPORT "SDL_image"	' SDL must be imported before SDL_image
	'IMPORT "SDL_ttf"

$$NB_PIXELS = 1000

TYPE TGLFUNCS
	FUNCADDR VOID .glBegin (GLenum)
	FUNCADDR VOID .glEnd ()
	FUNCADDR VOID .glVertex3f (GLfloat, GLfloat, GLfloat)
	FUNCADDR VOID .glClearColor (GLfloat, GLfloat, GLfloat, GLfloat)
	FUNCADDR VOID .glClear (GLbitfield)
	FUNCADDR VOID .glDisable (GLenum)
	FUNCADDR VOID .glEnable (GLenum)
	FUNCADDR VOID .glColor4ub (GLubyte,GLubyte,GLubyte,GLubyte)
	FUNCADDR VOID .glPointSize (GLfloat)
	FUNCADDR VOID .glHint (GLenum,GLenum)
	FUNCADDR VOID .glBlendFunc (GLenum,GLenum)
	FUNCADDR VOID .glMatrixMode (GLenum)
	FUNCADDR VOID .glLoadIdentity ()
	FUNCADDR VOID .glOrtho (GLdouble,GLdouble,GLdouble,GLdouble,GLdouble,GLdouble)
	FUNCADDR VOID .glRotatef (GLfloat,GLfloat,GLfloat,GLfloat)
	FUNCADDR VOID .glViewport (GLint,GLint,GLsizei,GLsizei)
	FUNCADDR VOID .glFogf (GLenum,GLfloat)
END TYPE


DECLARE FUNCTION main ()
DECLARE FUNCTION get_funcaddr (STRING funcname)
DECLARE FUNCTION VOID init_glfuncs (TGLFUNCS f)




FUNCTION get_funcaddr (STRING funcname)
	XLONG f
	
	f = SDL_GL_GetProcAddress(&funcname)
	IF (f)
		RETURN f
	ELSE
		PRINT "Unable to get function pointer for ",funcname
		RETURN 0
	END IF
	
END FUNCTION



FUNCTION VOID init_glfuncs(TGLFUNCS gl)

	gl.glBegin=get_funcaddr("glBegin")
	gl.glEnd=get_funcaddr("glEnd")
	gl.glVertex3f=get_funcaddr("glVertex3f")
	gl.glClearColor=get_funcaddr("glClearColor")
	gl.glClear=get_funcaddr("glClear")
	gl.glDisable=get_funcaddr("glDisable")
	gl.glEnable=get_funcaddr("glEnable")
	gl.glColor4ub=get_funcaddr("glColor4ub")
	gl.glPointSize=get_funcaddr("glPointSize")
	gl.glHint=get_funcaddr("glHint")
	gl.glBlendFunc=get_funcaddr("glBlendFunc")
	gl.glMatrixMode=get_funcaddr("glMatrixMode")
	gl.glLoadIdentity=get_funcaddr("glLoadIdentity")
	gl.glOrtho=get_funcaddr("glOrtho")
	gl.glRotatef=get_funcaddr("glRotatef")
	gl.glViewport=get_funcaddr("glViewport")
	gl.glFogf=get_funcaddr("glFogf")
	
END FUNCTION


FUNCTION main ()

	TGLFUNCS f
	int i
	SDL_Event event
	int done
	GLfloat pixels[]
	STRING gl_library 
	
	
	DIM pixels[$$NB_PIXELS * 3]
	gl_library = "OpenGL32.DLL"
	done = 0

	' Load the SDL library 
	IF (SDL_Init($$SDL_INIT_VIDEO) < 0 )
		PRINT "Couldn't initialize SDL:", CSTRING$(SDL_GetError())
		RETURN 1
	END IF

	'atexit(&SDL_Quit())
	
	IF (SDL_GL_SetAttribute($$SDL_GL_DOUBLEBUFFER,1)<0)
		PRINT "Unable to set GL attribute:", CSTRING$(SDL_GetError())
		RETURN 1
	END IF
	
	IF (SDL_GL_LoadLibrary(&gl_library)< 0)
		PRINT "Unable to dynamically open GL lib:", CSTRING$(SDL_GetError())
		RETURN 1
	END IF

	IF (SDL_SetVideoMode(640,480,0,$$SDL_OPENGL) == NULL)
		PRINT "Unable to open video mode:", CSTRING$(SDL_GetError())
		RETURN 1
	END IF

	' Set the window manager title bar 
	SDL_WM_SetCaption(&"SDL Dynamic OpenGL Loading Test",&"dyngl")

	init_glfuncs(@f)

	FOR i = 0 TO $$NB_PIXELS-1
		pixels[3*i]=rand()MOD 250-125
		pixels[3*i+1]=rand()MOD 250-125
		pixels[3*i+2]=rand()MOD 250-125
	NEXT i
	
	@f.glViewport(0,0,640,480)

	@f.glMatrixMode($$GL_PROJECTION)
	@f.glLoadIdentity()
	@f.glOrtho(-100,100,-100,100,-500,500)
	
	@f.glMatrixMode($$GL_MODELVIEW)
	@f.glLoadIdentity()
	
	@f.glEnable($$GL_DEPTH_TEST)
	@f.glDisable($$GL_TEXTURE_2D)
	@f.glEnable($$GL_BLEND)
	@f.glBlendFunc($$GL_SRC_ALPHA, $$GL_ONE_MINUS_SRC_ALPHA)
	
	@f.glClearColor(0.0,0.0,0.0,0.0)
	@f.glClear($$GL_COLOR_BUFFER_BIT | $$GL_DEPTH_BUFFER_BIT)
	
	@f.glEnable($$GL_POINT_SMOOTH)
	@f.glHint($$GL_POINT_SMOOTH_HINT,$$GL_NICEST)
	@f.glPointSize(5.0)
	@f.glEnable($$GL_FOG)
	@f.glFogf($$GL_FOG_START,-500)
	@f.glFogf($$GL_FOG_END,500)
	@f.glFogf($$GL_FOG_DENSITY,0.005)
	
	DO
		@f.glClear($$GL_COLOR_BUFFER_BIT | $$GL_DEPTH_BUFFER_BIT)
		
		@f.glRotatef(2.0,1.0,1.0,1.0)
		@f.glRotatef(1.0,0.0,1.0,1.0)
		
		@f.glColor4ub(255,255,255,255)

		@f.glBegin($$GL_POINTS)
		FOR i = 0 TO $$NB_PIXELS-1
			@f.glVertex3f(pixels[3*i],pixels[3*i+1],pixels[3*i+2])
		NEXT i
		@f.glEnd()
		
		SDL_GL_SwapBuffers()

		DO WHILE(SDL_PollEvent(&event))
			IF (event.type & $$SDL_KEYDOWN)
				done = 1
			END IF
		LOOP

		SDL_Delay(20)
	LOOP WHILE(!done)
	
	SDL_Quit()
	RETURN 0
	
END FUNCTION
END PROGRAM


