
'
'	Title:
'		SDL_gfx Example
'
'	Description:
'		This is an example of how to use the SDL_gfx DevKit.  After the dev kit
'		is installed into Dev-C++, you should be able to goto New Project and
'		see the SDL_gfx Example project available there.  SDL_gfx is a great
'		graphics library for SDL.  More information is available about it at
'		http:'www.ferzkopp.net/~aschiffler/Software/SDL_gfx-2.0/

'	Author:
'		Rob Loach (http:'www.robloach.net)

'	Date:
'		February 8th, 2005



PROGRAM "sdlgfx"
VERSION "0.1"
'CONSOLE

	IMPORT "msvcrt"
	IMPORT "gdi32"
	IMPORT "user32"
	IMPORT "kernel32"
	IMPORT "opengl32"	
	IMPORT "SDL"
	'IMPORT "SDL_mixer"
	IMPORT "SDL_gfx"
	'IMPORT "SDL_image"	' SDL must be imported before SDL_image
	'IMPORT "SDL_ttf"


' For more information about SDL_gfx, please visit their website at
' http:'www.ferzkopp.net/~aschiffler/Software/SDL_gfx-2.0/


DECLARE FUNCTION main ()
DECLARE FUNCTION lpSDL_Surface SDL_LoadBMP (lpfilename)
DECLARE FUNCTION SDL_BlitSurface (lpSDL_Surface src, lpSDL_Rect srcrect, lpSDL_Surface dst, lpSDL_Rect dstrect)
DECLARE FUNCTION pollevent()

FUNCTION main ()
	
	lpSDL_Surface lpscreen
	SDL_Surface screen
	SDL_Surface image
	lpSDL_Surface lpimage
	FPSmanager fpsm
	lpSDL_Surface lpimageRotated
	SDL_Surface imageRotated
	SDL_Rect rect
	double rotationAngle
	
	
	
	' Initialize SDL
	' Load the SDL library 
	IF (SDL_Init($$SDL_INIT_VIDEO) < 0 )
		PRINT "Couldn't initialize SDL:", CSTRING$(SDL_GetError())
		RETURN 1
	END IF

	' Initilize the screen
	lpscreen = SDL_SetVideoMode(400, 300, 32, $$SDL_HWSURFACE | $$SDL_DOUBLEBUF)
	IF (!lpscreen)
		PRINT "Unable to set video mode:", CSTRING$(SDL_GetError())
		SDL_Quit()
		RETURN 1
	ELSE
		memcpy(&screen,lpscreen,SIZE(screen))
	END IF
	

	' Load the image
	lpimage = SDL_LoadBMP(&"sample24.bmp")
	IFZ (lpimage)
		PRINT "Unable to load image: ", CSTRING$(SDL_GetError())
	END IF


	' FRAME RATE MANAGER EXAMPLE
	' Initialize Frame Rate Manager
	SDL_initFramerate(&fpsm)
	SDL_setFramerate(&fpsm, 60) ' 60 Frames Per Second
	rotationAngle = 0
	
	DO WHILE(!pollevent())
	 
		' Clear the screen
		SDL_FillRect(lpscreen, NULL, 0)

		' ROTOZOOM EXAMPLE
		' Make the new rotated image
		rotationAngle = rotationAngle + 0.3
		lpimageRotated = rotozoomSurface(lpimage, rotationAngle, 1, 0)
		memcpy(&imageRotated,lpimageRotated,SIZE(imageRotated))

		' Draw the rotated image
	
		rect.x = XLONG(screen.w >> 1) - XLONG(imageRotated.w >> 1)
		rect.y = XLONG(screen.h >> 1) - XLONG(imageRotated.h >> 1)
		SDL_BlitSurface(lpimageRotated, NULL, lpscreen, &rect)

		' Clear memory when finished with the rotated image
		SDL_FreeSurface(lpimageRotated)

		' GRAPHICS PRIMATIVES EXAMPLE
		filledCircleRGBA(lpscreen, 200, 200, 50, 255, 0, 0, 150)

		' Output to the screen
		SDL_Flip(lpscreen)


		' FRAME RATE MANAGER EXAMPLE
		' Delay using the frame rate manager
		SDL_framerateDelay(&fpsm)

	LOOP

	' Clean up the loaded image
	SDL_FreeSurface(lpimage)
	SDL_Quit()

	RETURN 0
	
END FUNCTION

FUNCTION SDL_BlitSurface (lpSDL_Surface src, lpSDL_Rect srcrect, lpSDL_Surface dst, lpSDL_Rect dstrect)

	RETURN SDL_UpperBlit(src, srcrect, dst, dstrect)	
END FUNCTION

FUNCTION lpSDL_Surface SDL_LoadBMP (lpfilename)

	RETURN SDL_LoadBMP_RW(SDL_RWFromFile(lpfilename, &"rb"), 1)
END FUNCTION

FUNCTION pollevent()

    SDL_Event event

    IF (!SDL_PollEvent(&event)) RETURN 0
    IF (event.type == $$SDL_QUIT) RETURN 1
    
    lpinkeys = SDL_GetKeyState(0)
	IF (lpinkeys)
		IF (UBYTEAT(lpinkeys + $$SDLK_ESCAPE)) RETURN 1
	END IF

    RETURN 0
END FUNCTION


END PROGRAM
