
' texture.bmp must be a 512x512 24b image


PROGRAM "sdltest"
VERSION "0.1"
'CONSOLE

	IMPORT "msvcrt"
	IMPORT "gdi32"
	IMPORT "user32"
	IMPORT "kernel32"

	IMPORT "SDL"
	'IMPORT "SDL_image"	' SDL must be imported before SDL_image
	'IMPORT "SDL_ttf"
	
	
DECLARE FUNCTION main ()

' set 32bit pixel colour
DECLARE FUNCTION VOID SetPixelRGB (SDL_Surface surface, int x, int y, int r, int g, int b)
' set 32bit pixel colour
DECLARE FUNCTION VOID SetPixelColour (SDL_Surface surface, int x, int y, lpSDL_Colour colour)

DECLARE FUNCTION SDL_BlitSurface (lpSDL_Surface src, lpSDL_Rect srcrect, lpSDL_Surface dst, lpSDL_Rect dstrect)

DECLARE FUNCTION lpSDL_Colour GetPixelColour (SDL_Surface surface, int x, int y)
DECLARE FUNCTION lpSDL_Surface SDL_LoadBMP (lpfilename)

DECLARE FUNCTION pollevent()

'http://lazyfooproductions.com/SDL_tutorials/

FUNCTION main ()

	lpSDL_Surface lpscreen, lpimage, lpbmptexture
	lpSDL_PixelFormat lppixformat
	SDL_Surface screen, bmptexture
	SDL_PixelFormat pixformat
	SDL_Rect rect
	XLONG distanceTable[],angleTable[]
	'XLONG texture[]
	float ratio,animation
	lpSDL_Colour color
	float value
	
	int angle
	XLONG distance
	
	texWidth = 512
	texHeight = 512
	screenWidth = 400
	screenHeight = 300

 	w = screenWidth
 	h = screenHeight

	'DIM texture[texWidth*2,texHeight*2]
	DIM distanceTable[2 * screenWidth,2 * screenHeight]
	DIM angleTable[2 * screenWidth, 2 * screenHeight]
	
	IF (SDL_Init($$SDL_INIT_EVERYTHING)) 
		RETURN 1
	END IF
	
	lpscreen = SDL_SetVideoMode (screenWidth, screenHeight, 32, $$SDL_HWSURFACE | $$SDL_DOUBLEBUF)
	IF (!lpscreen)
		SDL_Quit()
		RETURN 1
	END IF
	
	SDL_WM_SetCaption(&"SDL Tunnel", 0)
	lpbmptexture = SDL_LoadBMP(&"texture.bmp")
	
	memcpy(&bmptexture,lpbmptexture,SIZE(bmptexture))
	memcpy(&screen,lpscreen,SIZE(screen))
	'memcpy(&pixformat,bmptexture.format,SIZE(SDL_PixelFormat))

	'generate texture
	'FOR x = 0 TO texWidth-1
	'	FOR y = 0 TO texHeight-1
	'		texture[x,y] = (x * 256 / texWidth) ^ (y * 256 / texHeight)
	'	NEXT y
	'NEXT x

	ratio = 32.0
	
    FOR x = 0 TO (w*2)-1
    	FOR y = 0 TO (h*2)-1
 			value = SINGLE(sqrt(SINGLE((x - w) * (x - w) + (y - h) * (y - h))))
        	IF (value > 0.0)
        		distanceTable[x,y] = XLONG(ratio * texHeight / value) MOD texHeight
        	END IF
        	
        	angleTable[x,y] = XLONG(0.5 * texWidth * atan2(SINGLE(y - h), SINGLE(x - w)) / 3.1416)
		NEXT y
	NEXT x

   	DO WHILE(!pollevent())
   	
        animation = SDL_GetTicks() / 1000.0
		shiftX = XLONG(texWidth * 1.0 * animation)
		shiftY = XLONG(texHeight * 0.25 * animation)     
		shiftLookX = w / 2 + XLONG(w / 2 * sin(animation))
        shiftLookY = h / 2 + XLONG(h / 2 * sin(animation * 2.0))

		FOR x = 0 TO w-1
    		FOR y = 0 TO h-1
			'	color = texture[XLONG(distanceTable[x + shiftLookX,y + shiftLookY] + shiftX) MOD texWidth, XLONG(angleTable[x + shiftLookX,y + shiftLookY]+ shiftY) MOD texHeight]
				color = GetPixelColour(bmptexture,abs((distanceTable[x + shiftLookX,y + shiftLookY] + shiftX) & 511), abs((angleTable[x + shiftLookX,y + shiftLookY]+ shiftY) & 511))
				SetPixelColour(screen,x,y,color)
			NEXT y
		NEXT x

		SDL_Flip(lpscreen)
		Sleep(10)
   LOOP

	SDL_FreeSurface(lpbmptexture)
	SDL_Quit()

	RETURN 0	
END FUNCTION

FUNCTION lpSDL_Surface SDL_LoadBMP (lpfilename)

	RETURN SDL_LoadBMP_RW(SDL_RWFromFile(lpfilename, &"rb"), 1)
END FUNCTION

FUNCTION SDL_BlitSurface (lpSDL_Surface src, lpSDL_Rect srcrect, lpSDL_Surface dst, lpSDL_Rect dstrect)

	RETURN SDL_UpperBlit(src, srcrect, dst, dstrect)	
END FUNCTION


' 32bit surface
FUNCTION VOID SetPixelRGB (SDL_Surface surface, int x, int y, int r, int g, int b)

	'XLONGAT(surface.pixels + (y*(surface.w<<2)) + (x<<2)) = SDL_MapRGB(surface.format, r, g, b)	
	' or to save a function call...
	XLONGAT(surface.pixels + (y*surface.pitch) + (x << 2)) = (r << 16)|(g << 8)|b
END FUNCTION

' 32bit surface
FUNCTION VOID SetPixelColour (SDL_Surface surface, int x, int y, lpSDL_Colour colour)

	XLONGAT(surface.pixels + (y*surface.pitch) + (x<<2)) = colour
END FUNCTION


' 24bit surface
FUNCTION lpSDL_Colour GetPixelColour (SDL_Surface surface, int x, int y)

	RETURN XLONGAT(surface.pixels + y * surface.pitch + x * 3)
END FUNCTION


FUNCTION pollevent()

    SDL_Event event

    IF (!SDL_PollEvent(&event)) RETURN 0
    IF (event.type == $$SDL_QUIT) RETURN 1
    
    lpinkeys = SDL_GetKeyState(0)
	IF (lpinkeys)
		IF (UBYTEAT(lpinkeys + $$SDLK_ESCAPE)) RETURN 1
	END IF

    RETURN 0
END FUNCTION


END PROGRAM